#include "testlib.h"
#include<bits/stdc++.h>
#define all(A) A.begin(), A.end()
#define SZ(A) (int)A.size() 
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXN = 1e6;

template<class T> using matrix = vector<vector<T>>;

matrix<int> G;
vector<int> output, renode;

void dfs(int u = 1, int p = 0){
	if(u != 1){
		output[renode[u - 1]] = renode[p - 1];
	}
	for(auto v : G[u]){
		if(v == p) continue;
		dfs(v, u);
	}
}

int main(int argc, char **argv){
	registerGen(argc, argv, 1);
	bool binary = opt<bool>("binary");
	int n;
	if(!binary){
		n = opt<int>("n");
		G.resize(n + 1);
		long long tree = opt<long long>("tree");
		vector<int> p(n + 1);
		for(int u = 2; u <= n; u ++){
			p[u] = 1 + (u == 2 ? 0 : rnd.wnext(u - 2, tree));
			G[p[u]].push_back(u);
		}
	}
	else{
		int k = opt<int>("k");
		n = (1 << k) - 1;
		G.resize(n + 1);
		for(int i = 1; i <= n / 2; i ++){
			G[i].push_back(2 * i + 0);
			G[i].push_back(2 * i + 1);
		}
	}
	bool reshuffle = opt<bool>("reshuffle");
	renode.resize(n);
	iota(renode.begin(), renode.end(), 1);
	if(reshuffle){
		shuffle(renode.begin() + 1, renode.end());
	}
	output.resize(n + 1);
	dfs();
	cout << n << endl;
	for(int i = 2; i <= n; i ++){
		cout << output[i] << " ";
	} cout << endl;
}
